



       







                      SCR - THE SCRIPT FILE GENERATOR




                               Version 1.00




                            Made available from



                            ROCKAMOLIE SOFTWARE





               Yes, this product can be distributed without the
 
             express written permission of Major League Baseball.
















      
      SCR - The Script File Generator

      The SCR program was written by a frustrated Autocad user
      at Rockamolie Software (Rock-uh-mow-lee) who needed to
      find a way to better automate repetitive tasks.  Autocad
      provides for that need by allowing the use of script files. 
      Script files are very similar to macro files used by many
      popular programs, like Lotus 1-2-3, Word Perfect, and others,
      but there are differences.

      Anyone who knows how to use Autocad script files, also
      knows how frustrating it can be putting one together.  Even
      though the tasks in an Autocad script file may fill only five or
      six lines, the user must provide a copy of that code for each
      file they want to be affected by it.

      Rockamolie Software has developed SCR to help simplify the
      creation of Autocad script files.  SCR allows the user to create
      a blank form file containing a series of script commands, and
      store them in a library along with other form files.  SCR will
      read these libraries and create a script file from a list of
      drawing files provided by the user.

      SCR is a simple, versatile and fast way of creating script files
      for use with Autocad.  Rockamolie Software hopes that it will
      provide you with as much time savings as it has for us.


      Setting up SCR

      The file SCR-ROCK.EXE is a compressed data file that
      contains all of the files needed for use with the SCR program. 
      It should be copied directly to the disk that it will be executed
      from.  It is recommended that it be placed in it's own
      directory, for easier identification of the SCR program files.

      Once SCR-ROCK.EXE has been copied to the appropriate
      disk, simply change directories to where the file is located and
      type the command SCR-ROCK at the Dos prompt.  The file
      should then de-compress itself into that directory.  It is
      necessary that SCR-ROCK be de-compressed before SCR
      can execute properly.  Once de-compression is complete, the
      file SCR-ROCK.EXE can be deleted from the disk if desired.

      The user must then specify a valid directory on the disk for
      the storage of the script forms.  When SCR is run, it will
      always look for script form files in the specified directory.  To
      specify a form file directory for SCR, the user must add the
      variable SCRDIR to the Dos Environment Table.  This is
      accomplished by the use of the SET command.

      The format for adding SCRDIR to the environment table is as
      follows:

      
                  SET SCRDIR=<d:pathname>

      where d: is a valid drive designation and pathname is a valid
      directory path.  Invalid drive or path designations will result in
      an error message and program termination.  Please consult
      the Dos manual for further information on the SET command.

      The SET command can be added to the Autoexec.bat file in
      the root directory of the boot disk, or may be entered at the
      Dos prompt.  It is recommended that SET be placed in the
      Autoexec file so that it will be set each time the machine is
      turned on.

      The SCR program file may remain in the same directory as
      the script forms, or can be located in any other directory on
      the disk, but whatever directory the SCR.EXE is in, that
      directory should be added to the Dos PATH in the
      Autoexec.bat file.  It is not mandatory that this be done, as it
      is possible to run SCR through a batch file if desired, but it is
      recommended.


      The SCR Script Form

      The script form file is a 'template' file containing a list of script
      commands in their proper format and location.  Each form file
      will need to be in standard Ascii format and should have the
      same .SCR extension as a regular Autocad script file.

      There will be two differences between a standard Autocad
      script file and an SCR format file.  The first is that where a
      drawing file name would usually go, the user must place the
      following : <FILE>. (Case is not important <file> is
      equivalent to <FILE> in SCR).  The second is that the
      program will automatically place a 0 at the end of each script
      file to allow for the automatic exit to Dos from the Autocad
      menu, thus eliminating the need for the user to do it.

      A sample script form file may look something like this:

            Line One    :     2
            Line Two    :     <file>
            Line Three  :     Zoom
            Line Four   :     E
            Line Five   :     Wblock
            Line Six    :     <file>
            Line Seven  :     Y
            Line Eight  :     *
            Line Nine   :     Quit
            Line Ten    :     Y

      The file listed above would call up each drawing, perform a
      Zoom Extents, Write Block out the file to the same name, and
      finally Quit the drawing.
      
      When creating a script form file, it is best to use a text editor
      such as Edlin, or Brief.  Word processors such as Word
      Perfect can be used, but care must be taken to use the TEXT
      OUT option and to ensure that all unnecessary format codes
      are removed.  The form file should be created with care to
      ensure that there are no unwanted spaces, carriage
      returns/line feeds (returns), or other information.

      When executing SCR, the script file name can be replaced
      with a question mark (?) to obtain a help screen that will
      describe basic operation of the SCR program.


      The File List

      The optional file list will contain a list of files that SCR will
      generate a script file for.  It can be created in two formats. 
      One would be as a Dos DIR that has been redirected to a file. 
      The other would be as a user created file list.

      SCR will determine a USER produced file list from a DIR
      produced file list by the following rule:

            All files that start with a nil value, a space or
            a period as the first character of the file will
            be assumed to be a DIR produced file list.  It
            will then be assumed that the DWG drawing
            extension resides in the 10th, 11th and 12th
            positions of the DIR produced file list.

      To create a DIR produced file list, the user would type DIR >
      DIRLIST at the Dos prompt.  Dos would then do a standard
      directory, but instead of showing it on the screen, it would
      send the information to an Ascii text file called DIRLIST.  A
      typical redirected directory may look like this :

       Volume in drive C is DOS400     
       Volume Serial Number is 3448-1CCE
       Directory of  C:\UTIL\SCR

      .            <DIR>     09-24-90  12:49p
      ..           <DIR>     09-24-90  12:49p
      TREE     EXE      9202 09-26-90   2:15a
      ACAD     DWG      1977 10-06-88   8:51p
      AIRPLANE DWG     32219 11-04-88  11:29a
      BORDER   DWG      1585 11-23-87   9:04a
      CHAIR-3D DWG     83158 10-03-88  10:32a
      PLOT     SCR        29 09-24-90   4:17p
      PLOT2    SCR       125 09-24-90   5:47p
             10 File(s)   37892096 bytes free

      SCR will scan the above file, and extract all files with a .DWG
      extension.
      
      This option may be preferred if work needs to be done on
      files in several directories.  The user can do a DIR >  for each
      directory and simply merge each directory file into one long
      file list.

      The user may also create their own file lists.  Since a user
      created file may not be as consistent as a redirected DIR file,
      SCR will make some basic assumptions about how the files
      are laid out.

      First, SCR will assume that all files will begin at the left margin
      of the file.  Any lines that are found to have a leading space
      (a space as the first character of the line) will not be read into
      the file list.

      Next, SCR will scan each line of the user file to see if the first
      character is either a "\" or a "/".  These characters are used in
      path designations like \ACAD\DRAWINGS\COLUMBIA or
      /ACAD/DRAWINGS/COLUMBIA.  The "/" is allowed to
      accommodate the directory structure supported by Autolisp.

      Path designations without Drive designations must begin with
      either a "\" or "/" for SCR to work properly.  Although Dos may
      support specific path designations such as shown in "COPY
      ACAD\ACAD.LSP", SCR will not.  Path designations as in the
      above COPY command will be assumed to be a drawing file
      name.

      If neither of those characters are found to be the first
      character in the line being read from the file list, SCR will then
      search for ":" as the second character in the line.  If that
      character is found, SCR would assume the line contains a
      drive letter as in C:\ACAD\DRAWINGS\COLUMBIA.

      If none of the above cases are present, all trailing spaces will
      be removed from the line and SCR will then search each line
      for Reserved Characters.  Reserved Characters are listed
      below.

                  .                 A period
                  "                 A quote
                  /                 A forward slash
                  \                 A backward slash
                  [                 A left bracket
                  ]                 A right bracket
                  :                 A colon
                  |                 A 'more' designator
                  <                 A less than sign
                  >                 A greater than sign
                  +                 A plus
                  ;                 A semicolon
                  ,                 A comma
                  ?                 A question mark
                  *                 An asterisk
                  =                 An equals sign
                  <space>           A standard space
      
      If SCR finds any Reserved Characters in between characters
      in a line, it will truncate the line at the point the first one is
      found.

      An example of a VALID lines in a file list might be:

      C:\ACAD\DRAWINGS\COLUMBIA
      SITE-3D
      \ACAD\DRAWINGS\AIRPLANE
      /ACAD/DRAWINGS/BORDER
      ACAD     DWG      (commonly produced by DIR
      redirect)
      COLUMBIA DWG
      COLORIN DWG


      An example of an INVALID lines in a file list might be:

       C:\ACAD\COLUMBIA         (leading space)
      :\ACAD\AIRPLANE           (no drive letter)
      AUTOCAD\TREES             (name will be
      truncated)
      C:\ACAD\\NOZZLE           (too many \\ 's)

      The user should take caution to ensure that the file list is in a
      readable format.  Although SCR is designed to handle many
      possible situations, it cannot anticipate everything.


      Using SCR

      SCR can be executed with one or two command line
      arguments.  

      The command format for the program is as follows:

                  SCR {formfile} {filelist}

      Unlike {filelist}, {formfile} is a required parameter.  If SCR is
      invoked without this parameter, an error message will occur
      and the program will cease execution.  The ONLY exception
      to this would be if the user executed SCR ?.  If a question
      mark is used in place of a form file, SCR will generate a
      simple help screen to assist with the operation of SCR.

      {formfile} provides the name of a script format file located in
      the path defined in the SCRDIR environment variable.  This file
      must exist in that path and have an .SCR extension.  No path
      or drive designation is necessary for this parameter.

      {filelist} is an optional parameter.  If SCR is invoked without
      this parameter, it will automatically read all drawing files in the
      current directory and use this list in processing the script file. 
      

      To take advantage of this option, the user might create a
      temporary directory on the disk called C:\ACAD\TEMP, for
      example, and copy all files that need to be affected to the
      TEMP sub-directory.  They could then type CD \TEMP to
      change to the TEMP sub-directory containing the drawing files
      and finally type SCR {formfile}.  SCR would then read all
      drawing files in TEMP and create a script file using the form
      file {formfile}.

      If {filelist} is included as a parameter, it will provide the name
      of a user created file list that will be affected by the script file
      that is to be created.  It should be in the format outlined in the
      file list section of the documentation.

      If completed successfully, SCR will create a file called
      SCR.SCR in the current directory.


      Sample Program Executions

      Some examples of invoking SCR are listed below.

                  CD \ACAD\DRAWINGS
                  SCR WBLK-ALL 

            In the above example, the user changes to the
            DRAWINGS subdirectory and invokes SCR with
            the name of a script form file that will write block
            all drawings to eliminate unnecessary
            information.  Since the {filelist} parameter was
            not included, SCR will default to all drawings in
            the current directory and create the file
            SCR.SCR in the current directory,
            \ACAD\DRAWINGS.

                  SCR WBLK-ALL DIRLIST

            In the above example, the user invokes SCR
            with the same form file as was used above, but
            since the user provided a {filelist} parameter,
            SCR will read files from the DIRLIST file instead
            of reading all drawing files in the current
            directory.  SCR would assume that DIRLIST is in
            the current directory.

                  SCR WBLK-ALL
      C:\ACAD\DRAWINGS\DIRLIST

            In this example, the user invokes SCR with the
            same form file, but SCR will now search in the
            C:\ACAD\DRAWINGS directory for the DIRLIST
            file.

      
      Disclaimers, Proclamations, Etc.

      Rockamolie Software provides SCR under the following
      conditions/limitations :

            The original, compressed version of SCR-
            ROCK.EXE can be distributed freely to anyone,
            anywhere, anytime provided that the SCR-
            ROCK.EXE compress file is distributed AS IS
            and UNALTERED, and that ABSOLUTELY no
            cost is charged whatsoever for the software,
            including program files, documentation files, and
            all other files included with the package. 
            Allowances are recognized for the TRUE costs
            of any floppy diskettes needed to distribute the
            software, but these should reflect the
            reasonable market value of that type of floppy.

            There should be no charges made for printouts
            of any documentation or other files included
            with SCR, except for reasonable Xerox copy
            charges.  If a user would like to obtain a laser
            printout of the original Word Perfect file, simply
            send a self-addressed STAMPED (50 cents
            should cover it) envelope (regular or full page
            size) to the address listed below, and
            Rockamolie Software will send you one of your
            very own.
            No SCR files shall be de-compiled, renamed, or
            otherwise altered in any way for distribution
            copies.  Personal copies of the documentation
            can be altered, and files renamed for your
            convenience, but the files CANNOT be altered
            and then distributed.

            Rockamolie Software retains all rights to the
            source code of all programs included with the
            SCR package.  No one shall attempt to de-
            compile the program files to obtain the source
            code.  If it is ever found that someone is using
            source code from any Rockamolie Software
            product for personal gain except Rockamolie
            Software, We will do everything within our legal
            rights to prosecute those responsible to the
            fullest extent of the Law.

            Rockamolie Software makes no claims or
            warranties, implied or expressed, on this
            product.  It is provided at no charge in AS IS
            condition for personal use by individuals. 
            Although Rockamolie Software has vigorously
            tested the software and made sure it was free of
            any and all virus programs before release, We
            will not be held responsible for mishaps that
            may occur.  Especially if a copy has been
            hacked.
      
      Now that all of that is out of the way, it should be made clear
      that Rockamolie Software is asking for NO monetary
      compensation for this product.  It is provided out of a feeling
      of goodwill to all computer people.

      All that is asked is that the users please send
      CONSTRUCTIVE criticism, general comments, and requests
      for new features to Rockamolie Software so that feedback can
      be gained from the general public.  In this world of ever
      increasing software prices and 'get less for more' attitudes,
      We hope to build a better mouse trap for less.

      Please address comments and questions to:

                        Rockamolie Software
                        ATTN: PAUL SULLIVAN
                        P.O. Box 2441
                        Longview, WA  98632

      
